Subject: bug#52293: [External] : bug#52293: 29.0.50; [PATCH v3] Prevent further cases of duplicated separators in context menus

From: Drew Adams <[email-masked]>
Date: Thu, 16 Dec 2021 17:51:13 +0000

> >> Moreover, double-clicking mouse-3 is not convenient to use.
> >
> > I disagree.  I'll bet it's what you're already
> > doing when (if) you right-click `mouse-3' to
> > kill selected text.  I'll bet you do NOT use a
> > second single-click.
> 
> No, I don't use `mouse-3' to kill selected text,
> because it's easy to kill selected text
> by choosing "Cut" from the context menu.

Well, you were claiming, in general, that
double-clicking is not convenient.  Perhaps I should
have said that I'll be that it's what most users who
do use `mouse-3' to kill text do.

It seems you're maybe not the best placed to propose
that the traditional `mouse-3' behavior be shoved
under a bus, and just replaced by a context menu,
since you don't even use that traditional behavior.

I've argued that Emacs has great mouse behavior,
in particular wrt selection and deletion.  That's
comparing Emacs's mouse behavior with other mouse
behavior.  It's not comparing mouse behavior with
no mouse.

If someone does want to use the mouse for selecting
and deleting text, Emacs's mouse-3 behavior is great.

> > And anyway, it's not a double-click that brings
> > up a menu - that continues to do what it's always
> > done in Emacs: delete the active region.  It's a
> > _second single-click_ (at the same spot) that
> > brings up the menu.
> 
> So there should be a delay longer than for double-click
> before the second click pops up the context menu?

Users define the time period for a double-click.
They distinguish double-click from two clicks at the
same place.  Not a problem.  You can set that period
as brief as you like.

> > (That's a design choice, so as to fit best with
> > traditional Emacs behavior.  Those two could be
> > reversed: double-click to bring up menu, two
> > single-clicks to delete region.)
> 
> Still inconvenient when double-click brings up menu.

Your opinion's noted.  And your preference is easily
satisfied, as I explained.

Perhaps you're arguing for your preference to be the
_default_?  (That's what you're apparently doing
anyway, if your context-menu feature will, by default,
_replace_ the traditional mouse-3 behavior, instead
of being added and play well with that traditional
behavior.)

> > And again, there are simple user actions to get
> > ONLY what you apparently prefer or ONLY what
> > Emacs users are used to:
> >
> > . It's trivial to choose to always get a context
> >   menu instead (and yes, with a single click):
> >   just turn on option `mouse3-menu-always-flag'.
> 
> Maybe context menus should be enabled by default?

Clearly that's what you think.  I don't.  Not now.

Normally, we keep the default behavior when we add
a new, alternative behavior.  We add the new behavior
as an option (opt-in).

Then, after some experience and time and some user
feedback, we might consider changing the default
behavior.

I say "normally".  But we seem to no longer be in
normal times.  Dear Prudence ... won't you come out,
to play?"